
const CHILD_PAGES = Object.freeze({
    ACTIVITY_COUPONS: {
        JSON: '917_coupons.json',
        JS: '917_coupons.js'
    }
})

const IDS = Object.freeze({
    SUIT_SHOPS: 'suitShops',
    ACTIVITY_COUPONS: 'activityCoupons',
    SUBMIT: 'submit',
    GUIDE: 'guide'
})

function onLoadOfPage() {
    var tIsPreview = getInitDataByKey('isPreviewState');
    if (tIsPreview) {
        hideComponents([IDS.SUBMIT]);
    }
    var status = getInitDataByKey('status');
    if (status && status == 3) {
        var guideValue = JSON.parse(JSON.stringify(getComponentValue(IDS.GUIDE)));
        guideValue.content = '报名已审核通过，信息无法修改，若需要停止活动请联系官方微信 King07070515';
        setComponentValue(IDS.GUIDE, guideValue);
    }

    var tIsOutTime = getInitDataByKey('isOutTime');
    if (tIsOutTime) {
        JSExecutor.alertMsg('活动报名已经停止')
        hideComponents([IDS.SUBMIT]);
    }
}

function onLeftBtnClicked() {
    if (JSExecutor.hasDataUnsave()) {
        JSExecutor.alertMsgTitlesAction('内容有变更尚未保存，确定要退出吗？', ['取消', '确定'], function (index) {
            if (index == 1) {
                JSExecutor.exit(false);
            }
        });
    }
    else {
        JSExecutor.exit(false);
    }
}

/** 选择活动奖品即优惠券 */
function gotoSetCoupons() {
    var tIsLiansuo = getInitDataByKey('entityType') == ENTITY_TYPE_BRAND;
    var tSuitShops = getComponentValue(IDS.SUIT_SHOPS);

    if (tIsLiansuo) {
        if (!tSuitShops || tSuitShops.length == 0) {
            JSExecutor.alertMsg("为保证奖励优惠券适用门店与活动适用门店保持一致, 请先选择适用门店, 再设置活动奖品");
            return;
        }
    }

    //单店情况下需要给一个默认空列表
    if (!tIsLiansuo) {
        tSuitShops = [];
    }

    var tActivityCoupons = getComponentValue(IDS.ACTIVITY_COUPONS);
    if (!tActivityCoupons) {
        tActivityCoupons = {};
    }

    var tNextPageData = tActivityCoupons;
    var tNextPageExtendInfo = JSON.parse(JSON.stringify(mExtendInfo));
    tNextPageExtendInfo.init_data.suitShops = tSuitShops;
    JSExecutor.gotoSubpage(CHILD_PAGES.ACTIVITY_COUPONS.JSON, CHILD_PAGES.ACTIVITY_COUPONS.JS, tNextPageData, tNextPageExtendInfo);
}

function submit() {
    JSExecutor.getFormDataCallBack(function (failed, failedMessage, data) {
        if (failed) {
            JSExecutor.alertMsg(failedMessage);
        }
        else {
            var tParams = {
                'data': data,
            }

            var tRequestId = getInitDataByKey('request_id');
            if (tRequestId) {
                tParams.request_id = tRequestId;
            }

            if (getInitDataByKey('plate_entity_id')) {
                tParams.plate_entity_id = getInitDataByKey('plate_entity_id');
            }

            JSExecutor.requestWithAction('/nos_activity/v1/modify', 8, tParams, function (resText) {
                var tResData = JSON.parse(resText);
                if (tResData) {
                    var tNextParams = {};
                    if (tResData.requestId) {
                        tNextParams.request_id = tResData.requestId;
                    }
                    JSExecutor.routeWithUrlParams('tdf-manager://2dfire.com/member/nosRequestResult', tNextParams);
                    JSExecutor.exit(true);
                }
            });
        }
    })
}

/** 获得活动优惠券描述 */
function getValueTextOfActivityCoupons() {
    var tActivityCoupons = getComponentValue(IDS.ACTIVITY_COUPONS);
    if (tActivityCoupons && tActivityCoupons.coupons) {
        return tActivityCoupons.coupons.length + '张优惠券'
    }
    return '';
}

/** 接收优惠券设置页传过来的优惠券数据 */
function reveiveCoupons(activityCoupons) {
    if (activityCoupons && activityCoupons.coupons) {
        setComponentValue(IDS.ACTIVITY_COUPONS, activityCoupons);
    }
    else {
        setComponentValue(IDS.ACTIVITY_COUPONS, {});
    }
}
