////////////////////////////
/// common
////////////////////////////
function validateContent(failed, failedMessage) {
    if (failed == 1) {
        failedMessage += ''
        if (failedMessage.length > 0) {
            JSExecutor.alertMsg(failedMessage)
        }
        return false
    }

    return true
}

function hideComponents(compontIds, hide) {
    compontIds.forEach(function (c) {
        JSExecutor.setProp(c, 'hide', hide)
    })
}
////////////////////////////
/// mainpage
////////////////////////////
var typeRuleOnSelectValue;
var OperationTypeEnum = Object.freeze({ SAVE: 1, PUBLISH: 2 })

function adjustAddPrivilegeButtonVisible() {
    var shopEntityIds = currentShops().map(function (t) {
        return t.shopEntityId
    })

    JSExecutor.setProp('s_2_0', 'hide', shopEntityIds.length == 0)
    JSExecutor.setProp('s_2_0_0_0', 'hide', shopEntityIds.length == 0)// 规则类型选择 和满额优惠
}

function submitModification(opType) {
    JSExecutor.log(arguments.callee.name)

    JSExecutor.getFormDataCallBack(function (failed, failedMessage, data) {
        JSExecutor.log(data)

        if (!validateContent(failed, failedMessage) || !validateValidityDate()) { return false }
        else {
            submitFinalData(opType, data)
        }

    })
}

function submitFinalData(opType, data) {

    //mall日常项目中, 隐藏使用范围, 并默认为外卖堂食皆可用
    if (!data.applyScope) {
        data.applyScope = 3;
    }

    var extendInfo = JSExecutor.getExtendInfo()
    var activityId = extendInfo.activityId
    var activityType = extendInfo.activityType
    var plateEntityId = extendInfo.plateEntityId
    var params = {
        'activity_id': activityId,
        'activity_data': data,
        'option_type': opType,
        'plate_entity_id': plateEntityId,
        'activity_type': activityType
    }
    JSExecutor.submit('/plat/v1/modify_activity', params, 1);
}

//适用对象
function onloadofSuitPeople(){
    var extendInfo = JSExecutor.getExtendInfo()
   if (extendInfo.entityType == 4) {
       if(JSExecutor.getVal('suitPeople') == 2){
           JSExecutor.setProp('suitPeople','disable',1);
           JSExecutor.setProp('suitPeople','remark',"");
       }else{
           JSExecutor.setProp('suitPeople','disable',0);
           JSExecutor.setProp('suitPeople','remark',"选择不限时，即所有人都可参加此活动；选择全部会员时，即拥有特权卡（原会员卡）、新会员体系卡、会员等级特权卡的顾客可参与此活动；");
       }
   }
}

//消费满多少可得优惠
function onloadMoneyOffMinFee(){
    var extendInfo = JSExecutor.getExtendInfo()
    if (extendInfo.entityType == 4) {
        JSExecutor.setProp('s_2_0_0','remark',"");
    }
}

/** 检查积分适用门店: 若当前门店不在连锁积分适用范围内, 则提出二次确认提示: 本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认 */
function isPointUsageByBrand() {

    var extendInfo = JSExecutor.getExtendInfo()
    var isLiansuo = extendInfo['isChain']
    //当前门店是否在连锁积分适用范围内
    var isPointUsageByBrand = extendInfo['initialDataInfo']['isPointUsageByBrand']
    if (isPointUsageByBrand == undefined) isPointUsageByBrand = 1;
    JSExecutor.log('isLiansuo:' + isLiansuo + '; isPointUsageByBrand:' + isPointUsageByBrand)
    if (!isLiansuo && !isPointUsageByBrand) {
        return false;
    }
    return true;
}

function validateValidityDate() {
    JSExecutor.log(arguments.callee.name)

    var startDate = JSExecutor.getVal('s_3_0_0')
    var endDate = JSExecutor.getVal('s_3_0_1')

    if (startDate > 0 && JSExecutor.compoareToday(startDate) < 0) {
        JSExecutor.alertMsg('开始时间不得早于今天')
        return false
    }
    if (startDate > 0 && endDate > 0 && JSExecutor.dayCompare(endDate, startDate) < 0) {
        JSExecutor.alertMsg('结束时间不得早于开始时间')
        return false
    }
    return true
}

function isExistActivity() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()
    return extendInfo.activityId != null
}

function onload() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()

    JSExecutor.log(extendInfo)

    var isPreviewState = extendInfo.isPreviewState
    var remoteInfo = extendInfo.remoteInfo
    if (remoteInfo != null) {
        var permission = remoteInfo.permission
        var activityState = remoteInfo.activityState

        JSExecutor.setProp('s_3_6', 'hide', !(permission == 1 && activityState == 1))
        JSExecutor.setProp('s_3_6', 'disable', !(permission == 1 && activityState == 1))
        JSExecutor.setProp('s_3_5', 'hide', isPreviewState == 1)
    }
    // var isChain = extendInfo.isChain
    // var entityType = extendInfo.entityType;
    // if (isChain || entityType == 4) {
    //     JSExecutor.setProp('s_0_5', 'hide', 0);
    // } else {
    //     JSExecutor.setProp('s_0_5', 'hide', 1);
    // }

}

// 头部活动相关的提示
function onloadOfGuide() {
    var extendInfo = JSExecutor.getExtendInfo()
    var tGuideContent = extendInfo['initialDataInfo']['guide'];
    if (tGuideContent != undefined) {
        JSExecutor.setProp('guide', 'hide', 0)
        JSExecutor.setVal('guide', tGuideContent);
    }
}

function publish() {
    JSExecutor.log(arguments.callee.name)

    submitModification(OperationTypeEnum.PUBLISH)
}

function save() {
    JSExecutor.log(arguments.callee.name)

    if (isExistActivity() && !JSExecutor.hasDataUnsave()) {
        JSExecutor.alertMsg('未有任何改动，请点击返回')
        return
    }

    submitModification(OperationTypeEnum.SAVE)
}

function stop() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()
    var activityId = extendInfo['activityId']
    var params = { 'activity_id': activityId }
    JSExecutor.submit('/plat/v1/stop_activity', params, 1);
}

function s31OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var validOnScheduleTime = JSExecutor.getVal('s_3_1')
    hideComponents(['s_3_1_0', 's_3_1_1'], !validOnScheduleTime)
}

function s32OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var validOnSpcificWeekTime = JSExecutor.getVal('s_3_2')
    JSExecutor.setProp('s_3_2_0', 'hide', !validOnSpcificWeekTime)
}

function s33OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var validOnSpcificWeekTime = JSExecutor.getVal('s_3_3')
    JSExecutor.setProp('s_3_3_0', 'hide', !validOnSpcificWeekTime)
}

function deleteTriggerAmountPrivilege(itemIndex) {
    JSExecutor.log(arguments.callee.name)

    var privileges = JSExecutor.getVal('s_2_0')

    JSExecutor.log(privileges)
    privileges.splice(itemIndex, 1)

    JSExecutor.setVal('s_2_0', privileges)
}

function modifyTriggerAmountPrivilege(aPreferentialWay, itemIndex) {
    JSExecutor.log(arguments.callee.name)

    var privileges = JSExecutor.getVal('s_2_0')

    JSExecutor.log(privileges)
    if (itemIndex < 0) {
        privileges.push(aPreferentialWay)
    } else {
        privileges[itemIndex] = aPreferentialWay
    }

    privileges.sort(function (t, n) {
        return t.moneyOffMinFee - n.moneyOffMinFee
    })

    JSExecutor.setVal('s_2_0', privileges)
}


function applyShopsChanged() {
    JSExecutor.log(arguments.callee.name)

    // 清空选择的优惠券
    var preferentialWays = JSExecutor.getVal('s_2_0')
    if (preferentialWays != null && preferentialWays.length > 0) {
        preferentialWays.forEach(function (t) {
            if (t.coupons != null) {
                t.coupons.length = 0
            }
            t.couponSwitch = 0
        })
        JSExecutor.setVal('s_2_0', preferentialWays)
    }

    adjustAddPrivilegeButtonVisible()
}

function applyShopsLoad() {
    var extendInfo = JSExecutor.getExtendInfo()
    // if (extendInfo.isChain == 1) {
    adjustAddPrivilegeButtonVisible()
    // }
}

function s20OnPackageInputParam() {
    JSExecutor.log(arguments.callee.name)

    var inputParam = {}
    // 把shopEntityIds存入子页面入口组件
    var shops = currentShops()
    if (shops != null) {
        inputParam.shopEntityIds = shops.map(function (t) {
            return t.shopEntityId
        })
    }

    // 过滤相同的触发金额
    inputParam.triggerAmounts = JSExecutor.getVal('s_2_0').map(function (t) {
        return t.moneyOffMinFee
    })

    return inputParam
}
////////////////////////////
/// subpage
////////////////////////////

var DiscountTypeEnum = Object.freeze({ FIXED: 1, PRIVILEGE: 2 })

function subpageTriggerAmountPrivilegeOnload() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()
    JSExecutor.log(extendInfo)

    JSExecutor.setProp('s_2_0_5', 'hide', extendInfo.isPreviewState == 1 || extendInfo.itemIndex < 0)

    JSExecutor.setProp('s_2_0_3_0', 'inputParam', extendInfo.localInfo.shopEntityIds)

	if(extendInfo['valueForS2045'] != null){
		JSExecutor.setVal('s_2_0_4_5', extendInfo['valueForS2045'])
	}

    var discountOptions = []
    for (var i = 99; i >= 0; i--) {
        var si = i.toString()
        discountOptions.push({ 'value': si, 'showStr': si })
    }
    JSExecutor.setOptions('s_2_0_2_0_0', discountOptions)

    showSubPage(extendInfo['ruleType'])
}

// 获取当前的适用门店
function currentShops() {
    var suitShopsKey = 'suitShops';
    if (JSExecutor.getExtendInfo().entityType == 4) {
        suitShopsKey = 'mallSuitShops';
    }
    return JSExecutor.getVal(suitShopsKey);
}

//调用方为subpage, 目的是在上一个js上下文中获取上一个页面适用门店当前设置
function getShopsFromLastPage() {
    return JSExecutor.execParentContextFuncWithParams('currentShops', [])
}

function subpageSaveTriggerAmountPrivilege() {
    JSExecutor.log(arguments.callee.name)

    JSExecutor.getFormDataCallBack(function (isFailed, verifyFailedTip, formData) {
        JSExecutor.log(formData)

        if (!validateContent(isFailed, verifyFailedTip)) { return false }

        var extendInfo = JSExecutor.getExtendInfo()
        var triggerAmounts = extendInfo.localInfo.triggerAmounts

        var triggerAmount = JSExecutor.getVal('s_2_0_0')
        if (triggerAmount == 0) {
            JSExecutor.alertMsg('消费金额不可为0')
            return false
        }

        if (triggerAmounts != null) {
            var index = triggerAmounts.findIndex(function (t) {
                return t == triggerAmount
            })
            JSExecutor.log('index' + index)
            if (index != extendInfo.itemIndex && index != -1) {
                JSExecutor.alertMsg("单笔消费满金额【" + triggerAmount / 100.0 + "元】已存在！")
                return false
            }
        }

        // var anyPrivilegeSelected = ['s_2_0_4', 's_2_0_3', 's_2_0_2', 's_2_0_1', 'parkCouponSwitch']
        var anyPrivilegeSelected = ['s_2_0_4', 's_2_0_3', 's_2_0_2', 's_2_0_1', 's_2_0_6', 'parkCouponSwitch']
            .map(function (t) {
                return JSExecutor.getVal(t)
            })
            .reduce(function (r, n) {
                return r || n
            }, 0)

        if (!anyPrivilegeSelected) {
            JSExecutor.alertMsg('请至少选择一项优惠方式')
            return false
        }

        var pointsSwitch = JSExecutor.getVal('s_2_0_4')
        var points = JSExecutor.getVal('s_2_0_4_0')
        var pointRule = JSExecutor.getVal('s_2_0_4_1')
        //积分开关打开, 积分赠送方式为等比获得积分, 判断积分数是否填了
        if (pointsSwitch == 1 && pointRule == 2 && points == 0) {
            JSExecutor.alertMsg('积分处不能为0')
            return false
        }

        if (pointsSwitch == 1 && !isPointUsageByBrand()) {
            JSExecutor.alertMsgTitlesAction('本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认',
                ['取消', '确定'],
                function (index) {
                    if (index == 1) {
                        JSExecutor.execParentContextFuncWithParams('modifyTriggerAmountPrivilege', [formData, extendInfo.itemIndex])
                        JSExecutor.back()
                    }
                });
            return true;
        }

        JSExecutor.execParentContextFuncWithParams('modifyTriggerAmountPrivilege', [formData, extendInfo.itemIndex])
        JSExecutor.back()

        return true
    })
}

function subpageDeleteTriggerAmountPrivilege() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()
    JSExecutor.execParentContextFuncWithParams('deleteTriggerAmountPrivilege', [extendInfo.itemIndex])
    JSExecutor.back()
}

function s201OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var discount = JSExecutor.getVal('s_2_0_1')
    JSExecutor.setProp('s_2_0_1_0', 'hide', !discount)
}


function s202OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var discountWholeDeal = JSExecutor.getVal('s_2_0_2')
    JSExecutor.setProp('s_2_0_2_0', 'hide', !discountWholeDeal)

    s2020OnChanged()
}

function onloadOfRatioSelect() {
    var extendInfo = JSExecutor.getExtendInfo();
    if (extendInfo.entityType == 4) {
        var options = [{
            "value": "1",
            "showStr": "按固定折扣"
        }]
        JSExecutor.setOptions('s_2_0_2_0', options);
    }
}

function s2020OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var discountWholeDeal = JSExecutor.getVal('s_2_0_2_0')
    var isFixed = DiscountTypeEnum.FIXED == discountWholeDeal

    JSExecutor.setProp('s_2_0_2_0_0_2', 'hide', isFixed)
    hideComponents(['s_2_0_2_0_0', 's_2_0_2_0_0_1'], !isFixed)
}

function s203OnChanged() {
    JSExecutor.log(arguments.callee.name)

    JSExecutor.setProp('s_2_0_3_0', 'hide', !JSExecutor.getVal('s_2_0_3'))
}

function s206OnChanged() {
    JSExecutor.log(arguments.callee.name)

    var extendInfo = JSExecutor.getExtendInfo()
    var ruleType = extendInfo.ruleType
    var entityType = extendInfo.entityType
    // mall 且 是每满减
    if(entityType ==4 && ruleType == 1){
        JSExecutor.setProp('s_2_0_6_0', 'hide', !JSExecutor.getVal('s_2_0_6'))
        JSExecutor.setProp('s_2_0_6_1', 'hide', !JSExecutor.getVal('s_2_0_6'))
        JSExecutor.setProp('s_2_0_6_2', 'hide', !JSExecutor.getVal('s_2_0_6'))
    } else {
        JSExecutor.setProp('s_2_0_6', 'hide', 1)
    }
}

function s2061Delete(){
    JSExecutor.setVal('s_2_0_6', 0)
    JSExecutor.setVal('s_2_0_6_0', null)
    JSExecutor.setVal('s_2_0_6_2', null)

}


function s204OnChanged() {
    JSExecutor.log(arguments.callee.name)
    // var tSubComponentHide = !JSExecutor.getVal('s_2_0_4');
    // JSExecutor.setProp('s_2_0_4_1', 'hide', tSubComponentHide)
    // JSExecutor.setProp('s_2_0_4_4', 'hide', tSubComponentHide)
    // JSExecutor.setProp('s_2_0_4_5', 'hide', tSubComponentHide)
    var extendInfo = JSExecutor.getExtendInfo()
    showSubPage(extendInfo['ruleType'])
}

//积分赠送方式改变时触发
function onChangeOfPointRule() {
    var tSeletedVal = JSExecutor.getVal("s_2_0_4_1");
    //选择了每消费一定金额获得积分
    if (tSeletedVal == 1) {
        JSExecutor.setProp('s_2_0_4_0', 'hide', 1)
        JSExecutor.setProp('s_2_0_4_2', 'hide', 0)
        JSExecutor.setProp('s_2_0_4_3', 'hide', 0)
    }
    //选择了与消费金额等比获得积分
    else {
        JSExecutor.setProp('s_2_0_4_0', 'hide', 0)
        JSExecutor.setProp('s_2_0_4_2', 'hide', 1)
        JSExecutor.setProp('s_2_0_4_3', 'hide', 1)
    }
}

function onChangeOfParkingCouponSwitch() {
    var tParkingCouponSwitch = JSExecutor.getVal('parkCouponSwitch');
    if (tParkingCouponSwitch) {
        JSExecutor.setProp('parkCoupons', 'hide', 0)
    }
    else {
        JSExecutor.setProp('parkCoupons', 'hide', 1)
    }
}

function typeRuleOnSelect() { // 规则类型
    var extendInfo = JSExecutor.getExtendInfo()
    typeRuleOnSelectValue = JSExecutor.getVal('s_2_0_0_0');
    if (typeRuleOnSelectValue == 0) {
//        JSExecutor.alertMsg('typeRuleOnSelectValue = 0 阶梯满减')
        JSExecutor.setProp('s_2_0', 'ruleType', 0)
    } else if (typeRuleOnSelectValue == 1) {
        JSExecutor.setProp('s_2_0', 'ruleType', 1)
    }
    // var preferentialWays = JSExecutor.getVal('s_2_0')
    // JSExecutor.setVal('s_2_0', preferentialWays)
}
function willChangeTypeRule() {
   var preferentialWays = JSExecutor.getVal('s_2_0')
   preferentialWays = [];// 切换规则类型后需要清空优惠方式
   JSExecutor.setVal('s_2_0', preferentialWays)
    return true;
}
 
function showSubPage(typeRule) {
    var extendInfo = JSExecutor.getExtendInfo()
    JSExecutor.log(extendInfo.entityType);
    var tSubComponentHide = !JSExecutor.getVal('s_2_0_4');

    // var typeRuleOnSelectValue = JSExecutor.getVal('s_2_0_0_0');
    if (typeRule == 0) {//阶梯满减
        JSExecutor.setProp('s_2_0_0', 'title', '消费满多少元可得优惠')
        JSExecutor.setProp('s_2_0_2', 'hide', 0)
        if (tSubComponentHide) {
            JSExecutor.setProp('s_2_0_4_1', 'hide', tSubComponentHide)
            JSExecutor.setProp('s_2_0_4_5', 'hide', tSubComponentHide)
        } else {
            JSExecutor.setProp('s_2_0_4_1', 'hide', 0)//阶梯满减  pointRule 展示
            JSExecutor.setProp('s_2_0_4_5', 'hide', 1)// 阶梯满减模式下 赠送积分 隐藏
        }
        // 阶梯满减 s_2_0_0 remark 为
        JSExecutor.setProp('s_2_0_0', 'remark', '金额立减和整单打折同时开启时，先进行打折再满减。')
    } else if (typeRule == 1) {// 每满减
    // 子页逻辑
        JSExecutor.setProp('s_2_0_0', 'title', '每消费满多少元可得优惠')// 当选择每满减时，二级满额优惠设置页的文案变更如下增加【每】字，商圈设置的内容项不变，依然为优惠券和停车券，餐饮的设置项中去掉【整单打折】，赠送积分直接设置数量
        JSExecutor.setProp('s_2_0_2', 'hide', 1)// 当选择每满减时，赠送积分直接设置数量 餐饮的设置项中去掉【整单打折】
        if (tSubComponentHide) {
            JSExecutor.setProp('s_2_0_4_1', 'hide', tSubComponentHide)
            JSExecutor.setProp('s_2_0_4_5', 'hide', tSubComponentHide)
        } else {
            // JSExecutor.setVal('s_2_0_4_1', 1)// pointRule 默认选择 1  且 隐藏
            JSExecutor.setProp('s_2_0_4_1', 'hide', 1)//  pointRule 隐藏
            JSExecutor.setProp('s_2_0_4_5', 'hide', 0)//每满减模式下 赠送积分 展示
        }
        // 每满减 s_2_0_0 remark 为 空
        JSExecutor.setProp('s_2_0_0', 'remark', '')
        s206OnChanged() // IOS 并不会初始状态
    }
}

/** 适用范围 */
function onChangeOfApplyScope() {
    var value = JSExecutor.getVal('s_0_4');
    switch (parseInt(value)) {
        case 1:
            JSExecutor.setProp('s_0_4', 'remark', '');
            break;
        case 2:
            JSExecutor.setProp('s_0_4', 'remark', '外卖场景暂不支持赠送优惠券。');
            break;
        case 3:
            JSExecutor.setProp('s_0_4', 'remark', '外卖场景暂不支持赠送优惠券。');
            break;
        default:
            JSExecutor.setProp('s_0_4', 'remark', '');
            break;
    }
}