
var extendInfo = JSExecutor.getExtendInfo();
var activityId = extendInfo['activityId'];
var isPreView = extendInfo['isPreviewState'];
var activityType = extendInfo['activityType'];
var plateEntityId = extendInfo['plateEntityId'];
var isChain = extendInfo['isChain'];
var initialData = extendInfo['initialDataInfo'];
var shopName = initialData['shopName'];
var wechatPushTargets = initialData['wechatPushTargets'];
var officialAccountNum;
////////////////////////
////// onload
////////////////////////

function onload() {
	//每月几日数据源
	var options = [];
	for (var i = 0; i < 31; i++) {
		options[i] = {
			"value": (i + 1).toString(),
			"showStr": (i + 1).toString()
		};
	}
	JSExecutor.setOptions("s_0_1_1", options);
	//每周周几数据源
	options = [];
	for (var i = 0; i < 7; i++) {
		var id = i + 1;
		options[i] = {
			"value": id.toString(),
			"showStr": getWeek(id)
		}
	}

	JSExecutor.setOptions("s_0_1_2", options);
	var remoteInfo = getExtendInfo('remoteInfo');
	if (remoteInfo) {
		var permission = remoteInfo['permission'];
		var activityState = remoteInfo['activityState'];

		var stopBtnHide = (permission == 1 && activityState == 1) ? 0 : 1;
		JSExecutor.setProp('stopBtn', 'hide', stopBtnHide);
		JSExecutor.setProp('stopBtn', 'disable', stopBtnHide);
	}
	if (isPreView) {
		JSExecutor.setProp('s_3_0_5','hide',1);
		JSExecutor.setProp('saveBtn','hide','1');
	}
    JSExecutor.setProp('s_3_0_0_0', 'inputParam', {"activity_type": activityType})
}

function wxchatPushTargetOnload() {
	if (wechatPushTargets != undefined) {
		var options = [];
		for (var i = 0; i < wechatPushTargets.length; i++) {
			var wechatPushTarget = wechatPushTargets[i];
			var showStr;
			if (i != 0) {
				showStr = wechatPushTarget['showStr'];
			} else {
                if (isChain == 1) {
                    showStr = wechatPushTarget['showStr'] + '(' + '共' + officialAccountNum + '人' + ')';
                }else {
                    showStr = wechatPushTarget['showStr'] + '(' + '共' + wechatPushTarget['pushTargetNum'] + '人' + ')';
                }
			}
			options[i] = {
				"value": wechatPushTarget['pushTargetId'],
				"showStr": showStr
			};
		}
		JSExecutor.setOptions('s_2_1_0', options);
	}
	pushTarget();

	if (isChain == 1) {
		JSExecutor.setProp('s_2_1_0', 'customRemark', null);
		return;
	}
	var officialAccount = getInitialData('officialAccount');
	if (officialAccount) {
        setCustomRemarkValues('s_2_1_0', [officialAccount['nickName'], officialAccount['followerCount']])
	}
}

function wxDfireTagOnLoad() {
	var officialAccount = getInitialData('officialAccount');
	var officialAccountId = officialAccount['authorizerAppId'];
	if (officialAccountId != undefined && activityType != undefined) {
		JSExecutor.setProp('s_2_1_0_1', 'inputParam', {"authorizerAppId": officialAccountId,"activity_type": activityType})
	}
}

function pushTargetSMSOnload() {
	var pushTargets = getInitialData('smsPushTargets');
	if (pushTargets != undefined) {
		var options = [];
		for (var i = 0; i < pushTargets.length; i++) {
			var pushTarget = pushTargets[i];
			var showStr;
			if (i == pushTargets.length - 1) {
				showStr = pushTarget['showStr'];
			} else {
				showStr = pushTarget['showStr'] + '(' + '共' + pushTarget['pushTargetNum'] + '人' + ')';
			}
			options[i] = {
				"value": pushTarget['pushTargetId'],
				"showStr": showStr
			};
		}
		JSExecutor.setOptions('s_3_0_0', options);
	}
	pushTargetSMS();
}

function smsInfoOnLoad() {
	var smsNum = getInitialData('smsNum');
	JSExecutor.log(smsNum);
	if (smsNum != undefined) {
		JSExecutor.setVal('s_3_0_5', smsNum);
	}
}
/////////////////////////
//// on change
/////////////////////////

function holidayTime() {
	var seletType = JSExecutor.getVal('s_0_1');
	for (var i = 0; i < 4; i++) {
		var componentId = 's_0_1_' + i;
		JSExecutor.setProp(componentId, 'hide', seletType == i + 1 ? 0 : 1);
		JSExecutor.setProp('s_0_1_4', 'hide', seletType == 4 ? 0 : 1);
	}
}

function postCardSetting() {
	var postCard = JSExecutor.getVal('s_2_1_5');
	JSExecutor.setProp('s_2_1_5_0', 'hide', postCard == 1 ? 0 : 1);
}

function sendByWechat() {
	var value = JSExecutor.getVal('s_2_1');
	for (var i = 0; i < 10; i++) {
	    if(i == 9) {
	        if(isChain == 1) {
                JSExecutor.setProp('s_2_1_9', 'hide', value == 1 ? 0 : 1);
            }
	    }
	    else {
		    var componentId = 's_2_1_' + i;
		    JSExecutor.setProp(componentId, 'hide', value == 1 ? 0 : 1);
		}
	}
}

function sendByWeChatWillChange(value) {
    if (isChain == 0) {
        if (value == 1) {
        	var officialAccount = getInitialData('officialAccount');
        	if (officialAccount != undefined) {
                var verifyTypeInfo = officialAccount['verifyTypeInfo'];
                var officialAccountId = officialAccount['authorizerAppId'];
                var selfAuth = getInitialData('selfAuth');
                if (officialAccountId == null) {
                    JSExecutor.alertMsg('需完成公众号授权后，才可以使用此功能。请移步“公众号营销-店家公众号授权”');
                    return false;
                }
                if (selfAuth == 0) {
                    JSExecutor.alertMsg('自授权公众号才可以新建微信渠道活动');
                    return false;
                }
                if (verifyTypeInfo == -1) {
                    JSExecutor.alertMsg('您绑定的公众号未认证，无法使用此功能。请到微信公众号后台完成认证。');
                    return false;
                }
			}else  {
        		JSExecutor.alertMsg('需要完成公众号授权且授权公众号经过认证，否则无法使用此功能');
        		return false;
			}
        }
    }
    return true;
}

function sendTimeWillChange(value) {
	JSExecutor.log(value);
    var dateArray = value.split(":");
    JSExecutor.log(value);
    JSExecutor.log(dateArray);
    if (dateArray[0] == 3) {
        JSExecutor.alertMsg('3～4点为每日数据清理时间，不可选择此时间段发送');
        return false;
    }
    return true;
}

function sendBySMS() {
	var value = JSExecutor.getVal('s_3_0');
	for (var i = 0; i < 7; i++) {
		var componentId = 's_3_0_' + i;
		if(i == 5) {
		    if(isPreView == 0){
                JSExecutor.setProp('s_3_0_5', 'hide', value == 1 ? 0 : 1);
            }
		}
		else {
		    JSExecutor.setProp(componentId, 'hide', value == 1 ? 0 : 1);
		}
	}
}

function pushTarget() {
	var value = JSExecutor.getVal('s_2_1_0');
	JSExecutor.log(value);
	if (value == 1) {
		updateTagByPushTarget(value, 's_2_1_0_0', wechatPushTargets);
		JSExecutor.setProp('s_2_1_0_0', 'hide', 0);
		JSExecutor.setProp('s_2_1_0_1', 'hide', 1);
		return;
	}
	if (value == 3) {
		JSExecutor.setProp('s_2_1_0_0', 'hide', 1);
		JSExecutor.setProp('s_2_1_0_1', 'hide', 0);
		return;
	}
	JSExecutor.setProp('s_2_1_0_0', 'hide', 1);
	JSExecutor.setProp('s_2_1_0_1', 'hide', 1);
}

function pushTargetSMS() {
	var value = JSExecutor.getVal('s_3_0_0');
	JSExecutor.log(value);
	if (value == 7) {
		JSExecutor.setProp('s_3_0_0_0', 'hide', 0);
		return;
	}
	JSExecutor.setProp('s_3_0_0_0', 'hide', 1);
}

function updatePostCard(formData) {
	JSExecutor.log(formData);
	JSExecutor.setVal('s_2_1_5_0', formData);
}

function officialAccountChange() {
    if(isChain == 0) {
        return;
    }

	var officialAccount = JSExecutor.getVal('s_2_1_9');
	var officialAccountId;
	var subTags ;
	if (officialAccount.length > 0) {
		officialAccountId = officialAccount[0]['authorizerAppId'];
		officialAccountNum = officialAccount[0]['followerCount'];
		subTags = officialAccount[0]['subTags'];
	}else  {
        officialAccountNum = 0;
	}
	JSExecutor.log(subTags);
    setCustomRemarkValues('s_2_1_9', [officialAccount.length.toString(), officialAccountNum.toString()])
	// 更新微信标签分组的subTags数据源
	updateTags(subTags, 's_2_1_0_0');
	for (var i = 0; i < wechatPushTargets.length; i++) {
		var pushTarget = wechatPushTargets[i];
		if (pushTarget['pushTargetId'] == 1) {
			pushTarget['subTags'] = subTags;
			JSExecutor.log(pushTarget['subTags']);
			break;
		}
	}
	// 设置二维火标签的必要参数
	JSExecutor.setProp('s_2_1_0_1', 'inputParam', {"authorizerAppId": officialAccountId,"activity_type": activityType})

	//更新微信推送对象的option 将粉丝数拼上
	if (wechatPushTargets != undefined) {
		var options = [];
		for (var i = 0; i < wechatPushTargets.length; i++) {
			var wechatPushTarget = wechatPushTargets[i];
			var showStr;
			if (i == 0 && officialAccountNum) {
				showStr = wechatPushTarget['showStr'] + '(' + '共' + officialAccountNum + '人' + ')';
			}else {
				showStr = wechatPushTarget['showStr'];
			}
			options[i] = {
				"value": wechatPushTarget['pushTargetId'],
				"showStr": showStr
			};
		}
		JSExecutor.setOptions('s_2_1_0', options);
	}
}



///////////////////////
//// private method
///////////////////////

function getExtendInfo(key) {
	var extendInfo = JSExecutor.getExtendInfo();
	return extendInfo[key];
}

function getInitialData(key) {
	var initialData = getExtendInfo('initialDataInfo');
	if (initialData != undefined) {
		return initialData[key];
	}
}

function setCustomRemarkValues(id, values) {
    JSExecutor.setProp(id, 'customRemark.values', values);
}

function updateTagByPushTarget(pushTargetValue, tagComponentId, pushTargets) {
	for (var i = 0; i < pushTargets.length; i++) {
		var pushTarget = pushTargets[i];
		if (pushTargetValue == pushTarget['pushTargetId']) {
			var tags = pushTarget['subTags'];
			updateTags(tags, tagComponentId);
			return;
		}
	}
}

function updateTags(tags,tagComponentId) {
	var options = [];
	if (tags) {
		for (var i = 0; i < tags.length; i++) {
			var tag = tags[i];
			var showStr;
			if (tag['tagNum'] == null) {
				showStr = tag['showStr'];
			} else {
				showStr = tag['showStr'] + '(' + '共' + tag['tagNum'] + '人' + ')';
			}
			options[i] = {
				'value': tag['tagId'],
				'showStr': showStr
			};
		}
	}
	JSExecutor.setOptions(tagComponentId, options);
    var isHaveValue = false;
    var currValue = JSExecutor.getVal(tagComponentId);
    JSExecutor.log(currValue);
    if (currValue == undefined){
        return;
    }
    for (var i = 0; i < options.length; i++) {
        option = options[i];
        if (option['value'] == currValue){
            isHaveValue = true;
            break;
        }
    }
    if (isHaveValue == false) {
        JSExecutor.setVal(tagComponentId, null);
    }
	return;
}

function getWeek(index) {
	switch (index) {
		case (1):
			return "周日"
		case (2):
			return "周一"
		case (3):
			return "周二"
		case (4):
			return "周三"
		case (5):
			return "周四"
		case (6):
			return "周五"
		case (7):
			return "周六"
	}
}

///////////////////////
//// saveOrPublish
///////////////////////

function save() {
	var activityId = getExtendInfo['activityId'];
	if (activityId && JSExecutor.hasDataUnsave() != 1) {
		JSExecutor.alertMsg('未有任何改动，请点击返回');
		return;
	}
	saveOrPublish('1');
}

function stop() {
	var extendInfo = JSExecutor.getExtendInfo();
	var activityId = extendInfo['activityId'];
	var params = {
		'activity_id': activityId
	};
	JSExecutor.submit('/plat/v1/stop_activity', params, 1);
}

function publish() {
	saveOrPublish('2');
}

function saveOrPublish(opType) {
	JSExecutor.getFormDataCallBack(function(isFailed, verifyFailedTip, formData) {
		if (isFailed == 1) {
			verifyFailedTip += '';
			if (verifyFailedTip.length > 0) {
				JSExecutor.alertMsg(verifyFailedTip);
			}
			return false;
		}
		var dateType = JSExecutor.getVal('s_0_1');
		var circulateNum;
		switch (dateType) {
            case '1':
                circulateNum = 364;
                break;
            case '2':
                circulateNum = 28;
                break;
            case '3':
                circulateNum = 7;
                break;
            case '4':
                circulateNum = JSExecutor.getVal('s_0_1_4');
                break;
        }
        var daysBeforeActivity = JSExecutor.getVal('s_1_0');
        JSExecutor.log(daysBeforeActivity);
		if (daysBeforeActivity > circulateNum) {
			JSExecutor.alertMsg('提前几天时间不能大于循环期天数');
			return;
		}

		var pushWechat = JSExecutor.getVal('s_2_1');
		var pushSms    = JSExecutor.getVal('s_3_0');
		if (pushWechat == 0 && pushSms == 0) {
			JSExecutor.alertMsg('至少选择一种推送渠道！');
			return;
		}

        if (isChain == 0) {
            var officialAccount = getInitialData('officialAccount');
            if (officialAccount != undefined) {
                var officialAccountId = officialAccount['authorizerAppId'];
                if (officialAccountId != undefined && activityType != undefined) {
                    formData['wechatIds'] = [{"authorizerAppId": officialAccountId}];
                }
			}

        }
        JSExecutor.log(formData);
		// var opType = 2;
		var params = {
			'activity_id': activityId,
			'activity_data': formData,
			'option_type': opType,
			'plate_entity_id': plateEntityId,
			'activity_type': activityType
		};
		JSExecutor.submit('/plat/v1/modify_activity', params, 1);
	});
}

///////////////////////
//// subpage
///////////////////////

function postCardSubpagePublish() {
	JSExecutor.getFormDataCallBack(function(isFailed, verifyFailedTip, formData) {
		JSExecutor.log(formData);
		if (isFailed == 1) {
			verifyFailedTip += '';
			if (verifyFailedTip.length > 0) {
				JSExecutor.alertMsg(verifyFailedTip);
			}
			return false;
		}
		JSExecutor.execParentContextFuncWithParams('updatePostCard', [formData])
		JSExecutor.back()
	})
}