//-------------------------------------------- start of Main Page ---------------------------------------------//

//js中需要用到的组件id
var COMPONENT_ID = {
    CARD_SELECT: 's_0_0',
    PREFERENTIAL_ADD: 's_1_0',
    RECOMMEND_SWITCH: 's_2_1',
    RECOMMEND_RATE: 's_2_1_0',
    SELFCHARGE_SWITCH: 's_2_2',
    BUTN_SAVE: 'saveBtn',
    BUTN_STOP: 'stopBtn',
    AMOUNT_CHARGE: 's_1_0_0',
    AMOUNT_PRESENT: 's_1_0_2',
    POINT_PRESENT: 's_1_0_3',
    COUPONS_ADD: 's_1_0_4'
}

var EXTEND_INFO = JSExecutor.getExtendInfo();
//组件初始化数据
var INITIAL_DATA = EXTEND_INFO['initialDataInfo'];
//单一活动关联的扩展数据
var REMOTE_INFO = EXTEND_INFO['remoteInfo']
//活动类型
var ACTIVITY_TYPE = EXTEND_INFO['activityType'];
//是否连锁
var IS_CHAIN = EXTEND_INFO['isChain'];

var IS_RETAIL = EXTEND_INFO['isRetail'];

var OPERATION_TYPE_ENUM = Object.freeze({
    SAVE: 1,
    PUBLISH: 2
})

function onLoadOfPage() {
    if (REMOTE_INFO != undefined) {
        var tReadOnly = EXTEND_INFO['isPreviewState'] == 1 || REMOTE_INFO['activityState'] == 3;
        JSExecutor.setProp(COMPONENT_ID.BUTN_SAVE, 'hide', tReadOnly)
        JSExecutor.setProp(COMPONENT_ID.BUTN_STOP, 'hide', tReadOnly || REMOTE_INFO['activityState'] == 2)
    }

    //原有逻辑下, 已发布的活动可以直接切换其他特权卡并发布, 导致原有的特权卡上的卡充值优惠没有被清空掉.此处代码对这个bug进行修复. 
    //修复方式是, 已发布的活动不允许修改卡. 若想修改卡, 只能停止活动. 而停止活动时, 会将当前卡上的卡充值优惠全部清空. 
    if (REMOTE_INFO['activityState'] == 1) {
        JSExecutor.setProp(COMPONENT_ID.CARD_SELECT, 'disable', 1);
    }
}

/** 初始化会员卡 */
function onloadOfCard() {
    var tCard = JSExecutor.getVal(COMPONENT_ID.CARD_SELECT)
    if (tCard) {
        var tIncludeCardIds = new Array()
        tIncludeCardIds.push(tCard.id)
        var param = {
            "include_cards": tIncludeCardIds
        }
        var params = {
            "filter": param
        }
        JSExecutor.setProp(COMPONENT_ID.CARD_SELECT, 'inputParam', params);
    }
}

/** 选择会员卡后, 将自动充值开关设置为当前会员卡的属性值 */
function onChangeOfCardSelect() {
    var tCard = JSExecutor.getVal(COMPONENT_ID.CARD_SELECT);
    if (tCard != undefined) {
        JSExecutor.setVal(COMPONENT_ID.SELFCHARGE_SWITCH, tCard['isSelfRecharge']);
    }
}

function onChangeOfRecommendSwitch() {
    var recommendSwitchOn = JSExecutor.getVal(COMPONENT_ID.RECOMMEND_SWITCH);
    JSExecutor.setProp(COMPONENT_ID.RECOMMEND_RATE, 'hide', recommendSwitchOn == 0)
}

/** 检查自助充值开关是否打开, 若没打开, 则不允许当前开关打开 */
function beforeChangeOfRecommendSwitch(recommendSwitchState) {
    if (recommendSwitchState == 1) {
        var isSelfRecharge = JSExecutor.getVal(COMPONENT_ID.SELFCHARGE_SWITCH)
        if (isSelfRecharge == 0) {
            JSExecutor.alertMsg('你需要先打开允许顾客自助在线充值开关')
            return false
        } else {
            return true;
        }
    } else {
        return true;
    }
}

function onChangeOfSelfChargeSwitch() {
    var selfChargeSwitchState = JSExecutor.getVal(COMPONENT_ID.SELFCHARGE_SWITCH)

    if (selfChargeSwitchState == 0) {
        var isRecommend = JSExecutor.getVal(COMPONENT_ID.RECOMMEND_SWITCH)
        if (isRecommend == 1) {
            JSExecutor.setVal(COMPONENT_ID.RECOMMEND_SWITCH, 0)
        }
    }
}

function packageInputParamOfPreferentialAdd() {
    var tInputParam = {};
    tInputParam.triggerAmounts = JSExecutor
        .getVal(COMPONENT_ID.PREFERENTIAL_ADD)
        .map(function (t) {
            return t.triggerAmount.toString();
        })
    return tInputParam;
}

function modifyPreferentialWays(aPreferentialWay, itemIndex) {

    var preferentialWays = JSExecutor.getVal(COMPONENT_ID.PREFERENTIAL_ADD)

    if (itemIndex < 0) {
        preferentialWays.push(aPreferentialWay)
    } else {
        preferentialWays[itemIndex] = aPreferentialWay
    }

    preferentialWays.sort(function (t, n) {
        return t.triggerAmount - n.triggerAmount
    })

    JSExecutor.setVal(COMPONENT_ID.PREFERENTIAL_ADD, preferentialWays)
}

function delPreferentialWays(tItemIndex) {
    var preferentialWays = JSExecutor.getVal(COMPONENT_ID.PREFERENTIAL_ADD)
    preferentialWays.splice(tItemIndex, 1)
    JSExecutor.log(preferentialWays)
    JSExecutor.setVal(COMPONENT_ID.PREFERENTIAL_ADD, preferentialWays)
}

function save() {
    if (isExistActivity() && !JSExecutor.hasDataUnsave()) {
        JSExecutor.alertMsg('未有任何改动，请点击返回')
        return
    }

    submitModification(OPERATION_TYPE_ENUM.SAVE)
}


function publish() {
    JSExecutor.alertMsgTitlesAction('发布后将立即生效，顾客在微信、支付宝上充值时将享受到设置的优惠方案', ['取消', '确认'], function (index) {
        if (index == 1) {
            submitModification(OPERATION_TYPE_ENUM.PUBLISH);
        }
    });
}

function submitModification(opType) {

    JSExecutor.getFormDataCallBack(function (failed, failedMessage, data) {

        if (!validateContent(failed, failedMessage)) {
            return false
        }

        var activityId = EXTEND_INFO.activityId
        var activityType = EXTEND_INFO.activityType
        var params = {
            'activity_id': activityId,
            'activity_data': data,
            'option_type': opType,
            'activity_type': activityType
        }
        JSExecutor.submit('/plat/v1/modify_activity', params, 1);
    })
}

function stop() {
    JSExecutor.alertMsgTitlesAction('此操作将立即生效，是否确认立即停止在线充值优惠方案？', ['取消', '确认'], function (index) {
        if (index == 1) {
            var activityId = EXTEND_INFO['activityId']
            var params = {
                'activity_id': activityId
            }
            JSExecutor.submit('/plat/v1/stop_activity', params, 1);
        }
    });
}

//-------------------------------------------- end of Main Page ---------------------------------------------//


//-------------------------------------------- start of Sub Page ---------------------------------------------//

function onLoadOfSubPage() {
    if (IS_RETAIL) {
        JSExecutor.setProp('s_1_0_1', 'remark', '注：顾客在顾客端充值时，店家可随意输入一个充值金额，赠送方式会按最优的组合自动累加。如：充值100元赠送10元1个积分，充值200元赠送30元3个积分，那么充值500元先按两个200元，再加上一个100元来充值，顾客端自动充值时，顾客仅能享受单条设置的充值优惠，不能累加。');
        JSExecutor.setProp(COMPONENT_ID.COUPONS_ADD, 'hide', 1);
        JSExecutor.setProp('s_1_0_3_1', 'hide', 1)
    }
    if (REMOTE_INFO != undefined) {
        var tReadOnly = EXTEND_INFO['isPreviewState'] == 1 || REMOTE_INFO['activityState'] == 3;
        JSExecutor.setProp('delBtn', 'hide', tReadOnly)
    }
    var tItemIndex = EXTEND_INFO.itemIndex;
    if (tItemIndex < 0) {
        JSExecutor.setProp('delBtn', 'hide', 1)
    }
}

function saveActionOfPreferentialAdd() {
    if (checkPointsUsage()) {
        finalSaveActionOfPreferentialAdd()
    } else {
        JSExecutor.alertMsgTitlesAction('本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认', ['取消', '确定'],
            function (index) {
                if (index == 1) {
                    finalSaveActionOfPreferentialAdd()
                }
            });
    }
}

// 删除
function delActionOfPreferential() {
    var tItemIndex = EXTEND_INFO.itemIndex;
    JSExecutor.log(tItemIndex);
    JSExecutor.execParentContextFuncWithParams('delPreferentialWays', [tItemIndex])
    JSExecutor.back()
}

function finalSaveActionOfPreferentialAdd() {
    JSExecutor.getFormDataCallBack(function (isFailed, failedMsg, formData) {
        if (!validateContent(isFailed, failedMsg)) {
            return false
        }

        var tNewAmount = JSExecutor.getVal(COMPONENT_ID.AMOUNT_CHARGE)
        if (tNewAmount == 0) {
            JSExecutor.alertMsg("充值金额满不能为0！")
            return false;
        }

        var tExistAmounts = EXTEND_INFO.localInfo.triggerAmounts
        var tItemIndex = EXTEND_INFO.itemIndex;

        if (tExistAmounts) {
            var tMatchedIndex = tExistAmounts.findIndex(function (t) {
                return parseFloat(t) == tNewAmount
            })
            if (tMatchedIndex != tItemIndex && tMatchedIndex != -1) {
                JSExecutor.alertMsg("充值金额满【" + parseInt(tNewAmount) / 100 + "元】优惠已存在！")
                return false
            }
        }

        JSExecutor.execParentContextFuncWithParams('modifyPreferentialWays', [formData, tItemIndex])
        JSExecutor.back()

        return true
    })
}

function checkPointsUsage() {
    var pointsSwitch = JSExecutor.getVal('POINT_PRESENT');
    if (pointsSwitch > 0 && !isPointUsageByBrand()) {
        return false;
    }
    return true;
}

/** 检查积分适用门店: 若当前门店不在连锁积分适用范围内, 则提出二次确认提示: 本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认 */
function isPointUsageByBrand() {

    var extendInfo = JSExecutor.getExtendInfo()
    var isLiansuo = extendInfo['isChain']
    //当前门店是否在连锁积分适用范围内
    var isPointUsageByBrand = extendInfo['initialDataInfo']['isPointUsageByBrand']
    if (isPointUsageByBrand == undefined) isPointUsageByBrand = 1;
    JSExecutor.log('isLiansuo:' + isLiansuo + '; isPointUsageByBrand:' + isPointUsageByBrand)
    if (!isLiansuo && !isPointUsageByBrand) {
        return false;
    }
    return true;
}


//-------------------------------------------- end of Sub Page ---------------------------------------------//


//-------------------------------------------- start of common ---------------------------------------------//

function validateContent(failed, failedMessage) {
    if (failed == 1) {
        failedMessage += ''
        if (failedMessage.length > 0) {
            JSExecutor.alertMsg(failedMessage)
        }
        return false
    }
    return true
}

function isExistActivity() {
    return EXTEND_INFO.activityId != undefined
}

//-------------------------------------------- end of common ---------------------------------------------//