
//-------------------------------------------- start of Main Page ---------------------------------------------//

//js中需要用到的组件id
var COMPONENT_ID = {
    CARD_SELECT: 's_0_0',
    PREFERENTIAL_ADD: 's_1_0',
    RECOMMEND_SWITCH: 's_2_1',
    RECOMMEND_RATE: 's_2_1_0',
    SELFCHARGE_SWITCH: 's_2_2',
    BUTN_SAVE: 'saveBtn',
    BUTN_STOP: 'stopBtn',
    AMOUNT_CHARGE: 's_1_0_0',
    AMOUNT_PRESENT: 's_1_0_2',
    POINT_PRESENT: 's_1_0_3'
}

var EXTEND_INFO = JSExecutor.getExtendInfo();
//组件初始化数据
var INITIAL_DATA = EXTEND_INFO['initialDataInfo'];
//单一活动关联的扩展数据
var REMOTE_INFO = EXTEND_INFO['remoteInfo']
//活动类型
var ACTIVITY_TYPE = EXTEND_INFO['activityType'];
//是否连锁
var IS_CHAIN = EXTEND_INFO['isChain'];

var IS_RETAIL = EXTEND_INFO['isRetail'];

var OPERATION_TYPE_ENUM = Object.freeze({ SAVE: 1, PUBLISH: 2 })

function onLoadOfPage() {
    if (REMOTE_INFO != undefined) {
        var tReadOnly = EXTEND_INFO['isPreviewState'] == 1 || REMOTE_INFO['activityState'] == 3;
        JSExecutor.setProp(COMPONENT_ID.BUTN_SAVE, 'hide', tReadOnly)
        JSExecutor.setProp(COMPONENT_ID.BUTN_STOP, 'hide', tReadOnly || REMOTE_INFO['activityState'] == 2)
    }
}

/** 选择会员卡后, 将自动充值开关设置为当前会员卡的属性值 */
function onChangeOfCardSelect() {
    var tCard = JSExecutor.getVal(COMPONENT_ID.CARD_SELECT);
    if (tCard != undefined) {
        JSExecutor.setVal(COMPONENT_ID.SELFCHARGE_SWITCH, tCard['isSelfRecharge']);
    }
}

function onChangeOfRecommendSwitch() {
    var recommendSwitchOn = JSExecutor.getVal(COMPONENT_ID.RECOMMEND_SWITCH);
    JSExecutor.setProp(COMPONENT_ID.RECOMMEND_RATE, 'hide', recommendSwitchOn == 0)
}

/** 检查自助充值开关是否打开, 若没打开, 则不允许当前开关打开 */
function beforeChangeOfRecommendSwitch(recommendSwitchState) {
    if (recommendSwitchState == 1) {
        var isSelfRecharge = JSExecutor.getVal(COMPONENT_ID.SELFCHARGE_SWITCH)
        if (isSelfRecharge == 0) {
            JSExecutor.alertMsg("คุณต้องเปิดใช้งาน ‘อนุญาตให้ผู้ใช้ 2Dfire ทั้งหมดเติมเงินอัตโนมัติ'")
            return false
        }
        else {
            return true;
        }
    }
    else {
        return true;
    }
}

function onChangeOfSelfChargeSwitch() {
    var selfChargeSwitchState = JSExecutor.getVal(COMPONENT_ID.SELFCHARGE_SWITCH)

    if (selfChargeSwitchState == 0) {
        var isRecommend = JSExecutor.getVal(COMPONENT_ID.RECOMMEND_SWITCH)
        if (isRecommend == 1) {
            JSExecutor.setVal(COMPONENT_ID.RECOMMEND_SWITCH, 0)
        }
    }
}

function packageInputParamOfPreferentialAdd() {
    var tInputParam = {};
    tInputParam.triggerAmounts = JSExecutor
        .getVal(COMPONENT_ID.PREFERENTIAL_ADD)
        .map(function (t) {
            return t.triggerAmount.toString();
        })
    return tInputParam;
}

function modifyPreferentialWays(aPreferentialWay, itemIndex) {

    var preferentialWays = JSExecutor.getVal(COMPONENT_ID.PREFERENTIAL_ADD)

    if (itemIndex < 0) {
        preferentialWays.push(aPreferentialWay)
    } else {
        preferentialWays[itemIndex] = aPreferentialWay
    }

    preferentialWays.sort(function (t, n) {
        return t.triggerAmount - n.triggerAmount
    })

    JSExecutor.setVal(COMPONENT_ID.PREFERENTIAL_ADD, preferentialWays)
}

function delPreferentialWays(tItemIndex) {
    var preferentialWays = JSExecutor.getVal(COMPONENT_ID.PREFERENTIAL_ADD)
    preferentialWays.splice(tItemIndex, 1)
    JSExecutor.log(preferentialWays)
    JSExecutor.setVal(COMPONENT_ID.PREFERENTIAL_ADD, preferentialWays)
}

function save() {
    if (isExistActivity() && !JSExecutor.hasDataUnsave()) {
        JSExecutor.alertMsg('ไม่มีการปรับเปลี่ยนคลิกเพื่อกลับ')
        return
    }

    submitModification(OPERATION_TYPE_ENUM.SAVE)
}


function publish() {
    JSExecutor.alertMsgTitlesAction('เมื่อเปิดตัวโครงการส่วนลดจะได้รับการซิงค์กับการเข้าถึงเมนู E-Menu ทั้งหมด', ['ยกเลิก', 'ยืนยัน'], function (index) {
        if (index == 1) {
            submitModification(OPERATION_TYPE_ENUM.PUBLISH);
        }
    });
}

function submitModification(opType) {

    JSExecutor.getFormDataCallBack(function (failed, failedMessage, data) {

        if (!validateContent(failed, failedMessage)) {
            return false
        }

        var activityId = EXTEND_INFO.activityId
        var activityType = EXTEND_INFO.activityType
        var params = {
            'activity_id': activityId,
            'activity_data': data,
            'option_type': opType,
            'activity_type': activityType
        }
        JSExecutor.submit('/plat/v1/modify_activity', params, 1);
    })
}

function stop() {
    JSExecutor.alertMsgTitlesAction('จะมีผลทันทีทันใดแน่ใจหรือไม่ว่าจะหยุดการเติมเงินออนไลน์?', ['ยกเลิก', 'ยืนยัน'], function (index) {
        if (index == 1) {
            var activityId = EXTEND_INFO['activityId']
            var params = { 'activity_id': activityId }
            JSExecutor.submit('/plat/v1/stop_activity', params, 1);
        }
    });
}

//-------------------------------------------- end of Main Page ---------------------------------------------//


//-------------------------------------------- start of Sub Page ---------------------------------------------//

function onLoadOfSubPage() {
    if (IS_RETAIL) {
        JSExecutor.setProp('s_1_0_1', 'remark', 'หมายเหตุ：เมื่อทำการเติมเงินใน 2Dfire สามารถใส่ยอดการเติมเงินได้ตามสมัครใจ การแจกเงินโบนัสและคะแนนสะสมจะเป็นไปตามข้อกำหนด เช่น เติม 100 หยวนได้ฟรี 10 หยวน กับอีก 1 คะแนนสะสม และคูปองโปรโมชั่น 1 ใบ เติม 200 หยวน ได้ฟรี 30 หยวน กับอีก 3 คะแนนสะสม และคูปองโปรโมชั่น 2 ใบและหากต้องการเติมเงิน 500 หยวนให้เติมครั้งละ 200 หยวนสองครั้งก่อนแล้วค่อยเพิ่มอีก 100 หยวน หากเติมเงินครั้งเดียวจะได้รับสิทธิพิเศษแค่ครั้งเดียวเท่านั้น');
    }
    if (REMOTE_INFO != undefined) {
        var tReadOnly = EXTEND_INFO['isPreviewState'] == 1 || REMOTE_INFO['activityState'] == 3;
        JSExecutor.setProp('delBtn', 'hide', tReadOnly)
    }
    var tItemIndex = EXTEND_INFO.itemIndex;
    if (tItemIndex < 0) {
        JSExecutor.setProp('delBtn', 'hide', 1)
    }
}

function saveActionOfPreferentialAdd() {
    if (checkPointsUsage()) {
        finalSaveActionOfPreferentialAdd()
    }
    else {
        JSExecutor.alertMsgTitlesAction('ร้านค้าไม่สามารถใช้กับจุดของขวัญภายในร้าน HQ',
            ['ยกเลิก', 'ยืนยัน'],
            function (index) {
                if (index == 1) {
                    finalSaveActionOfPreferentialAdd()
                }
            });
    }
}

// 删除
function delActionOfPreferential() {
    var tItemIndex = EXTEND_INFO.itemIndex;
    JSExecutor.log(tItemIndex);
    JSExecutor.execParentContextFuncWithParams('delPreferentialWays', [tItemIndex])
    JSExecutor.back()
}

function finalSaveActionOfPreferentialAdd() {
    JSExecutor.getFormDataCallBack(function (isFailed, failedMsg, formData) {
        if (!validateContent(isFailed, failedMsg)) {
            return false
        }

        var tNewAmount = JSExecutor.getVal(COMPONENT_ID.AMOUNT_CHARGE)
        if (tNewAmount == 0) {
            JSExecutor.alertMsg("มูลค่าเติมเงินไม่สามารถเป็นศูนย์")
            return false;
        }

        var tExistAmounts = EXTEND_INFO.localInfo.triggerAmounts
        var tItemIndex = EXTEND_INFO.itemIndex;

        if (tExistAmounts) {
            var tMatchedIndex = tExistAmounts.findIndex(function (t) {
                return t == tNewAmount
            })
            if (tMatchedIndex != tItemIndex && tMatchedIndex != -1) {
                JSExecutor.alertMsg("โครงการมีอยู่แล้ว!")
                return false
            }
        }

        JSExecutor.execParentContextFuncWithParams('modifyPreferentialWays', [formData, tItemIndex])
        JSExecutor.back()

        return true
    })
}

function checkPointsUsage() {
    var pointsSwitch = JSExecutor.getVal('POINT_PRESENT');
    if (pointsSwitch > 0 && !isPointUsageByBrand()) {
        return false;
    }
    return true;
}

/** 检查积分适用门店: 若当前门店不在连锁积分适用范围内, 则提出二次确认提示: 本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认 */
function isPointUsageByBrand() {

    var extendInfo = JSExecutor.getExtendInfo()
    var isLiansuo = extendInfo['isChain']
    //当前门店是否在连锁积分适用范围内
    var isPointUsageByBrand = extendInfo['initialDataInfo']['isPointUsageByBrand']
    if (isPointUsageByBrand == undefined) isPointUsageByBrand = 1;
    JSExecutor.log('isLiansuo:' + isLiansuo + '; isPointUsageByBrand:' + isPointUsageByBrand)
    if (!isLiansuo && !isPointUsageByBrand) {
        return false;
    }
    return true;
}


//-------------------------------------------- end of Sub Page ---------------------------------------------//


//-------------------------------------------- start of common ---------------------------------------------//

function validateContent(failed, failedMessage) {
    if (failed == 1) {
        failedMessage += ''
        if (failedMessage.length > 0) {
            JSExecutor.alertMsg(failedMessage)
        }
        return false
    }
    return true
}

function isExistActivity() {
    return EXTEND_INFO.activityId != undefined
}

//-------------------------------------------- end of common ---------------------------------------------//
