// 保存or发布 opType: 1-保存; 2-发布
function saveOrPublish(opType) {
    JSExecutor.getFormDataCallBack(function (isFailed, verifyFailedTip, formData) {
        if (isFailed == 1) {
            verifyFailedTip += '';
            if (verifyFailedTip.length > 0) {
                JSExecutor.alertMsg(verifyFailedTip);
            }
            return false;
        }
        // 是否设置活动礼品
        var verifyGift = function () {
            var couponSwitchClose = JSExecutor.getVal('s_1_0') != 1;
            var pointsSwitchClose = JSExecutor.getVal('s_1_1') != 1;
            var balanceSwitchClose = JSExecutor.getVal('s_1_2') != 1;
            if (couponSwitchClose && pointsSwitchClose && balanceSwitchClose) {
                return false;
            }
            return true;
        }

        if (!verifyGift()) {
            JSExecutor.alertMsg('您未设置活动礼品，请设置');
            return;
        }
        var verifyDate = function () {
            var startDate = JSExecutor.getVal('s_3_0');
            var endDate = JSExecutor.getVal('s_3_1');
            if (startDate > 0 && JSExecutor.compoareToday(startDate) < 0) {
                JSExecutor.alertMsg('开始时间不得早于今天');
                return false;
            }
            if (startDate > 0 && endDate > 0 && JSExecutor.dayCompare(endDate, startDate) < 0) {
                JSExecutor.alertMsg('结束时间不得早于开始时间');
                return false;
            }
            return true;
        }
        if (!verifyDate()) {
            return;
        }

        var extendInfo = JSExecutor.getExtendInfo();
        var activityId = extendInfo['activityId'];
        var activityType = extendInfo['activityType'];
        var plateEntityId = extendInfo['plateEntityId'];
        // var opType = 2;
        var params = {
            'activity_id': activityId,
            'activity_data': formData,
            'option_type': opType,
            'plate_entity_id': plateEntityId,
            'activity_type': activityType
        };
        JSExecutor.submit('/plat/v1/modify_activity', params, 1);
    });
}

// 头部活动相关的提示
function onloadOfGuide() {
    var tGuideContent = JSExecutor.getExtendInfo()['initialDataInfo']['guide'];
    if (tGuideContent != undefined) {
        JSExecutor.setProp('guide', 'hide', 0)
        JSExecutor.setVal('guide', tGuideContent);
    }
}

//发布
function publish() {
    if (checkPointsUsage()) {
        saveOrPublish('2');
    }
    else {
        JSExecutor.alertMsgTitlesAction('本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认',
            ['取消', '确定'],
            function (index) {
                if (index == 1) {
                    saveOrPublish('2');
                }
            });
    }
}
//保存
function save() {
    var extendInfo = JSExecutor.getExtendInfo();
    var activityId = extendInfo['activityId'];
    if (activityId && JSExecutor.hasDataUnsave() != 1) {
        JSExecutor.alertMsg('未有任何改动，请点击返回');
        return;
    }
    if (checkPointsUsage()) {
        saveOrPublish('1');
    }
    else {
        JSExecutor.alertMsgTitlesAction('本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认',
            ['取消', '确定'],
            function (index) {
                if (index == 1) {
                    saveOrPublish('1');
                }
            });
    }
}

//停止
function stop() {
    var extendInfo = JSExecutor.getExtendInfo();
    var activityId = extendInfo['activityId'];
    var params = {
        'activity_id': activityId
    };
    JSExecutor.submit('/plat/v1/stop_activity', params, 1);
}

function getShopEntityIds(shops) {

    if (shops == undefined || shops.length == 0) {
        return null;
    }
    var map = function (shop) {
        return shop.shopEntityId;
    }

    var shopEntityIds = new Array();
    for (var i = 0, j = 0; i < shops.length; i++) {
        var shopEntityId = map(shops[i]);
        if (shopEntityId != undefined && shopEntityId != null) {
            shopEntityIds[j] = shopEntityId;
            j++;
        }
    }
    return shopEntityIds;
}


// 店铺变动 更新 组件入参
function setShopsInputParam() {
    var shops = JSExecutor.getVal('s_0_0');
    var shopEntityIds = getShopEntityIds(shops);
    JSExecutor.setProp('s_0_1', 'inputParam', shopEntityIds);
    JSExecutor.setProp('s_1_0_0', 'inputParam', shopEntityIds);
    JSExecutor.setProp('s_2_0_0_0_0', 'inputParam', shopEntityIds);
    JSExecutor.setProp('s_2_0_1_0_0', 'inputParam', shopEntityIds);
    JSExecutor.setProp('s_2_0_2_0_0', 'inputParam', shopEntityIds);
    return shopEntityIds;
}

var needChainTip = false;
// 店铺变动 清除 组件值
function setShopsValNull() {
    JSExecutor.setVal('s_0_1', null);
    JSExecutor.setVal('s_1_0_0', null);
    JSExecutor.setVal('s_2_0_0_0_0', null);
    JSExecutor.setVal('s_2_0_1_0_0', null);
    JSExecutor.setVal('s_2_0_2_0_0', null);
}

//参与门店 - 值加载
function shopsOnload() {
    isChain = true;
    var shopIds = setShopsInputParam();
    var hide = ((shopIds == undefined) || (shopIds == null) || (shopIds.length == 0)) ? 1 : 0;
    JSExecutor.setProp('s_1_0', 'hide', hide);
    needChainTip = hide == 1;
}

//参与门店 - 值变动
function shopsChange() {
    setShopsValNull();
    shopsOnload();
}

// 根据 switch 控件开启or关闭 显示or隐藏 组件
function showOrHide(switchId, operationId) {
    var isSwitchOpen = JSExecutor.getVal(switchId) == 1;
    JSExecutor.setProp(operationId, 'hide', isSwitchOpen ? 0 : 1);
}

// 分享有礼 开关  -- 隐藏显示
function shareGiftSwitchChange() {
    var hide = (JSExecutor.getVal('s_2_0') == 1) ? 0 : 1;
    JSExecutor.setProp('s_2_0_0', 'hide', hide);
    JSExecutor.setProp('s_2_0_1', 'hide', hide);
    JSExecutor.setProp('s_2_0_2', 'hide', hide);
    if (needChainTip && hide == 0) {
        JSExecutor.alertMsg('当前未选择适用门店，请选择活动适用门店');
    }
}

// onload
function onload() {
    var extendInfo = JSExecutor.getExtendInfo();
    var isPreviewState = extendInfo['isPreviewState'];
    var hide = (isPreviewState == 1) ? 1 : 0;
    JSExecutor.setProp('saveBtn', 'hide', hide);
    var remoteInfo = extendInfo['remoteInfo'];
    var permission = remoteInfo['permission'];
    var activityState = remoteInfo['activityState'];

    var stopBtnHide = (permission == 1 && activityState == 1) ? 0 : 1;
    JSExecutor.setProp('stopBtn', 'hide', stopBtnHide);
    JSExecutor.setProp('stopBtn', 'disable', stopBtnHide);

}

function checkPointsUsage() {
    var pointsSwitch = JSExecutor.getVal('pointsSwitch') ||
        JSExecutor.getVal('pointsSwitch1') ||
        JSExecutor.getVal('pointsSwitch5') ||
        JSExecutor.getVal('pointsSwitch10');

    if (pointsSwitch == 1 && !isPointUsageByBrand()) {
        return false;
    }
    return true;
}

/** 检查积分适用门店: 若当前门店不在连锁积分适用范围内, 则提出二次确认提示: 本店不在连锁积分适用范围内，因此赠送的积分不能在连锁中使用，请确认 */
function isPointUsageByBrand() {

    var extendInfo = JSExecutor.getExtendInfo()
    var isLiansuo = extendInfo['isChain']
    //当前门店是否在连锁积分适用范围内
    var isPointUsageByBrand = extendInfo['initialDataInfo']['isPointUsageByBrand']
    if (isPointUsageByBrand == undefined) isPointUsageByBrand = 1;
    JSExecutor.log('isLiansuo:' + isLiansuo + '; isPointUsageByBrand:' + isPointUsageByBrand)
    if (!isLiansuo && !isPointUsageByBrand) {
        return false;
    }
    return true;
}