const IDS = {
    STATUS: 'status',
    GOODSPRICE: 'price',
    PRECOMMISSION: 'preCommission',
    COMMISSIONRATE: 'commissionRate'
}


// 点击左侧导航按钮 
function onLeftBtnClicked() {
    if (JSExecutor.hasDataUnsave()) {
        JSExecutor.alertMsgTitlesAction('内容有变更尚未保存，确定要退出吗？', ['取消', '确定'], function (index) {
            if (index == 1) {
                JSExecutor.exit(false);
            }
        });
    }
    else {
        JSExecutor.exit(false);
    }
}

// 点击右侧导航按钮 保存
function onRightBtnClicked() {
    JSExecutor.getFormDataCallBack(function (failed, failedMessage, data) {
        if (failed) {
            JSExecutor.alertMsg(failedMessage);
            return;
        }
        else {
            var tdata = {
                "commissionRate": getComponentValue(IDS.COMMISSIONRATE),
                "goodsIds": getInitDataByKey('goodsId')
            };
            var params = { "param": JSON.stringify(tdata) };
            JSExecutor.requestWithAction('com.dfire.mmt.agent.marketagentsoa.client.service.IMicroAgentService.modifyAgentItem', 3, params, function (data) {
                JSExecutor.exit(true);
            });
        }
    })
}

function statusOfOnload() {
    var tStatus = getOriginData('status');
    if (tStatus == '1') {
        JSExecutor.setOldVal(IDS.STATUS, "已上架");
        setComponentValue(IDS.STATUS, "已上架");
    }
    else {
        JSExecutor.setOldVal(IDS.STATUS, "已下架");
        setComponentValue(IDS.STATUS, "已下架");
    }
}

function preCommissionOfOnChange() {
    var tPrice = getComponentValue(IDS.GOODSPRICE);
    var tCommissionRate = getComponentValue(IDS.COMMISSIONRATE);
    if (tPrice && tCommissionRate) {
        tCommissionRate = accDiv(tCommissionRate, 100.00);
        var tPreCommission = accMul(tPrice, tCommissionRate);
        if (tPreCommission < 0.01) tPreCommission = 0.01;
        JSExecutor.setOldVal(IDS.PRECOMMISSION, tPreCommission);
        setComponentValue(IDS.PRECOMMISSION, tPreCommission);
    }
}

function goodsRemoveBtnAction() {
    JSExecutor.alertMsgTitlesAction('移除后代理将不能再通过该商品获得佣金，但已发生的交易不受影响。', ['取消', '确定'], function (index) {
        if (index == 1) {
            var data = {
                "goodsIds": getInitDataByKey('goodsId')
            };
            var params = { "param": JSON.stringify(data) };
            JSExecutor.requestWithAction('com.dfire.mmt.agent.marketagentsoa.client.service.IMicroAgentService.removeAgentItem', 3, params, function (data) {
                JSExecutor.exit(true);
            });
        }
    });

}
